#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "macros.h"

#define CONTAINER_OF(ptr, type, field) \
	((type *)((unsigned long)(ptr) - (unsigned long)(&((type *)(0))->field)))

typedef int (*prioq_compare_t)(struct prioq_head *a, struct prioq_head *b);

struct prioq_head {
	int index;
};
	
struct user_data {
	int               data;
	struct prioq_head head;
};		


int main(void){
	
	struct user_data  ar[6], *up;
	struct prioq_head* ptr;
	
	unsigned int i;	
	
	for (i = 0; i<6; i++) {
		ar[i].data       = i;
		ar[i].head.index = i;
	}
     
    for (i = 0; i<6; i++) {
		ptr = &ar[i].head;
		up  = CONTAINER_OF(ptr, struct user_data, head);
		printf("%d\n", up->data);
	}
	return 0;
}